/////////////////////////////////////////////////////////////////
//             SpaceUV - By samuel Kvaalen                     //
//This plugins spaces out and aligns the selected points       //
//of a UV map according to the first and last selected points. //
/////////////////////////////////////////////////////////////////

@version 2.2
@warnings
@script modeler
@name "Space UV"


main
{
vmap = VMap(VMTEXTURE) || error("No UV map");
selmode(USER);
editbegin();
pc = pointcount();
if(pc>2)
{
if(vmap.isMapped(points[1]) && vmap.isMapped(points[pc]))
{
ptf = vmap.getValue(points[1]);
ptl = vmap.getValue(points[pc]);

Udis = abs((ptf[1]+(-ptl[1]))/(pc+(-1)));
Vdis = abs((ptf[2]+(-ptl[2]))/(pc+(-1)));

if(ptf[1]<ptl[1]){
for(i=2;i<pc;i++){
    minU = ptf[1];
    if(vmap.isMapped(points[i]))
    {
    valU = minU+((i+(-1))*Udis);
    valV = vmap.getValue(points[i]);
    vmap.setValue(points[i],@valU,valV[2]@);
    }
}
}

else if(ptl[1]<ptf[1]){
for(i=2;i<pc;i++){
    minU = ptl[1];
    if(vmap.isMapped(points[i]))
    {
    valU = minU+((pc+(-i))*Udis);
    valV = vmap.getValue(points[i]);
    vmap.setValue(points[i],@valU,valV[2]@);
    }
}
}

else if(ptl[1]==ptf[1]){
for(i=2;i<pc;i++){
    minU = ptl[1];
    if(vmap.isMapped(points[i]))
    {
    valU = minU;
    valV = vmap.getValue(points[i]);
    vmap.setValue(points[i],@valU,valV[2]@);
    }
}
}

editend();
editbegin();

if(ptf[2]<ptl[2]){
for(i=2;i<pc;i++){
    minV = ptf[2];
    if(vmap.isMapped(points[i]))
    {
    valU = vmap.getValue(points[i]);
    valV = minV+((i+(-1))*Vdis);
    vmap.setValue(points[i],@valU[1],valV@);
    }
}
}

else if(ptl[2]<ptf[2]){
for(i=2;i<pc;i++){
    minV = ptl[2];
    if(vmap.isMapped(points[i]))
    {
    valU = vmap.getValue(points[i]);
    valV = minV+((pc+(-i))*Vdis);
    vmap.setValue(points[i],@valU[1],valV@);
    }
}
}

else if(ptl[2]==ptf[2]){
for(i=2;i<pc;i++){
    minV = ptl[2];
    if(vmap.isMapped(points[i]))
    {
    valU = vmap.getValue(points[i]);
    valV = minV;
    vmap.setValue(points[i],@valU[1],valV@);
    }
}
}

}
}
}
